#pragma once
#include "Entity.h"
#include "EntityState.h"
#include "EntityStateFlashEffect.h"
#include "EntityStateInvincible.h"
#include "CS_QuoteGravity.h"
#include "CS_JackWater.h"
#include "CS_JackDrown.h"
#include "CS_JackControl.h"
#include "CS_JackResist.h"
#include "CS_JackJump.h"
#include "CS_JackStand.h"
#include "CS_JackMove.h"
#include "CS_JackAir.h"
#include "CS_JackFaceToBack.h"
#include "CS_JackHurt.h"
#include "CS_JackBubbler.h"
#include "CS_JackCatcher.h"
#include "CS_JackLevelReset.h"
#define CS_JACK_CREATENAME L"CS_mychar_jack"
//玩家角色 杰克
class CS_Jack :
	public MyCharEntity
{
public:
	CS_Jack();
	void Init(std::weak_ptr<Entity> self) override;
	void Step() override;
	void SetState(int stateID, int lr) override;
	void SetState(std::wstring stateName, int lr) override;
	void LoadSaveData() override;//加载保存数据
	void WriteSaveData() override;//写入保存数据
	bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
	void Gain(std::weak_ptr<Entity> item) override;
	void Destroy() override;
	void GetIcon(std::wstring& png, std::wstring& sprite_index, int& image_index, std::set<int>& hideLayerList) override;
	void CrushDeath();
	void CopyFrom(std::shared_ptr<Entity>& another) override;//让自己获得另一个和自己同类型实体一模一样的属性
	void GetAnimateOffset(float& outDx, float& outDy) override;//取动画偏移
	//图层显示
	bool showGun = false;//显示枪
	float animation_moveSpeed = 0x200 / ts;
	bool animation_delay = false;//走路动画延迟一帧（对齐到整格）
	//状态模块
	EntityStateFlashEffect stateFlash;
	EntityStateInvincible stateInvincible;
	CS_QuoteGravity stateGravity;
	CS_JackWater stateWater;
	CS_JackDrown stateDrown;
	CS_JackControl stateControl;
	CS_JackResist stateResist;
	CS_JackJump stateJump;
	CS_JackStand stateStand;
	CS_JackMove stateMove;
	CS_JackAir stateAir;
	CS_JackFaceToBack stateFaceToBack;
	CS_JackHurt stateHurt;
	//技能模块
	CS_JackBubbler skillBubbler;
	CS_JackCatcher skillCatcher;
	CS_JackLevelReset skillLevelReset;
	//其他变量
	std::wstring crushEvent;
private:
	void AnimateStep();//动画
};

std::shared_ptr<Entity> CreateCS_Jack();